


--Buslinien voll dissolven und explodieren

create table bus_attrib as
select distinct
a.geometry as geometry,
count(b.geometry) as anzahl,
group_concat(b.name,'; ') as linienliste
from bus_r_ce as a inner join buslinien as b on intersects(buffer(a.geometry,1),b.geometry)
where b.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='buslinien' AND search_frame=a.geometry)
group by a.geometry
;


create table buslinien_grupp as
select distinct
casttomultilinestring(gunion(geometry)) as geometry,
anzahl as anzahl,
linienliste as linienliste
from bus_attrib
group by linienliste
;
Select RecoverGeometryColumn('buslinien_grupp','Geometry',25832,'MULTILINESTRING');
Select CreateSpatialIndex('buslinien_grupp','Geometry');
SELECT UpdateLayerStatistics('buslinien_grupp');
----------------------------------------
------------------------------


-------------------
---Ohne borherige Bearbeitung
create table buslinien as

SELECT 
geometry as geometry,
name as name,
type as type,
other_tags as other_tags
FROM multilinestrings
where (name like '%tram%' or other_tags like '%tram%' or name like '%subway%' or other_tags like '%subway%');


Select RecoverGeometryColumn('buslinien','Geometry',25832,'MULTILINESTRING');
Select CreateSpatialIndex('buslinien','Geometry');
SELECT UpdateLayerStatistics('buslinien');


--Übertragen  auf die dissolvten und explodierten multinienstrinsg

create table buslinien_diss as
Select
1 as id,
Gunion(Geometry) as geometry
from buslinien
group by NULL;

Select RecoverGeometryColumn('buslinien_diss','Geometry',25832,'multilinestring');
Select CreateSpatialIndex('buslinien_diss','Geometry');
SELECT UpdateLayerStatistics('buslinien_diss');

--

select ElementaryGeometries('buslinien_diss','Geometry','buslinien_diss_ele','pk_id','multi_id');


Select RecoverGeometryColumn('buslinien_diss_ele','Geometry',25832,'linestring');
Select CreateSpatialIndex('buslinien_diss_ele','Geometry');
SELECT UpdateLayerStatistics('buslinien_diss_ele');

--------------------------
-----------------------------


-------------

create table bus_attrib as
select distinct
a.geometry as geometry,
count(b.geometry) as anzahl,
group_concat(b.name,'; ') as linienliste
from buslinien_diss_ele as a inner join buslinien as b on ST_Within(a.geometry,b.geometry)
where b.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='buslinien' AND search_frame=a.geometry)
group by a.geometry
;


--
create table buslinie_grupp as
select distinct
casttomultilinestring(gunion(geometry)) as geometry,
anzahl as anzahl,
linienliste as linienliste
from bus_attrib
group by linienliste
;
Select RecoverGeometryColumn('buslinie_grupp','Geometry',25832,'MULTILINESTRING');
Select CreateSpatialIndex('buslinie_grupp','Geometry');
SELECT UpdateLayerStatistics('buslinie_grupp');

select dropgeotable('bus_attrib');

select dropgeotable('buslinien_diss');

select dropgeotable('buslinien_diss_ele');




---Stadtbahn gesamtskript
--  Mit bezug zum stadtbahnnetz
-----------------------------------

create table tramlinien as

SELECT 
geometry as geometry,
name as name,
type as type,
other_tags as other_tags
FROM multilinestrings
where (name like '%tram%' or other_tags like '%tram%' or name like '%subway%' or other_tags like '%subway%');


Select RecoverGeometryColumn('tramlinien','Geometry',25832,'MULTILINESTRING');
Select CreateSpatialIndex('tramlinien','Geometry');
SELECT UpdateLayerStatistics('tramlinien');



create table stadtbahn as

select
a.ogc_fid as ogc_fid,
a.name as  nam,
a.railway as railway,
a.geometry as geometry
from lines as a inner join tramlinien as b on st_intersects(a.geometry,buffer(b.geometry,1))

where   "railway" in ( 'tram','light_rail','rail','subway')
   and  b.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='tramlinien' AND search_frame=a.geometry);


Select RecoverGeometryColumn('stadtbahn','Geometry',25832,'linestring');
Select CreateSpatialIndex('stadtbahn','Geometry');
SELECT UpdateLayerStatistics('stadtbahn');

----

select ElementaryGeometries('stadtbahn','Geometry','stadtbahn_ele','pk_id','multi_id');

Select CreateSpatialIndex("stadtbahn",'Geometry');


-------------

create table tram_attrib as
select distinct
a.geometry as geometry,
count(b.geometry) as anzahl,
group_concat(b.name,'; ') as linienliste
from stadtbahn_ele as a inner join tramlinien as b on ST_Within(a.geometry,buffer(b.geometry,1))
where b.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='tramlinien' AND search_frame=a.geometry)
group by a.geometry
;

--
create table tramlinien_grupp2 as
select distinct
casttomultilinestring(gunion(geometry)) as geometry,
anzahl as anzahl,
linienliste as linienliste
from tram_attrib
group by linienliste
;
Select RecoverGeometryColumn('tramlinien_grupp2','Geometry',25832,'MULTILINESTRING');
Select CreateSpatialIndex('tramlinien_grupp2','Geometry');
SELECT UpdateLayerStatistics('tramlinien_grupp2');

 replace(
 (regexp_replace(  "linienliste" ,'[A-TV-Za-z]','')),
 '=>','')




 regexp_replace(  "linien" ,'[äüöß :]','')
replace( "linien" ,';',',')



create table tram_linien2(
fid INTEGER PRIMARY KEY AUTOINCREMENT,
anzahl integer (3),
linienliste varchar,
liniennr varchar,
l1 integer,
l2 integer,
l3 integer,
l4 integer,
l5 integer,
l6 integer,
l7 integer,
l8 integer,
l9 integer,
l10 integer,
l11 integer,
l12 integer,
l13 integer,
l14 integer,
l15 integer,
l16 integer,
l17 integer,
l18 integer,
l19 integer,
l66 integer,
l67 integer,
li_liste varchar,
maximu integer,
mitte integer,
minim integer,
geometry geometry)
;
Select RecoverGeometryColumn('tram_linien2','Geometry',25832,'Multilinestring');

insert into tram_linien2
(geometry,
anzahl,
linienliste)
select
geometry,
anzahl,
linienliste
from tramlinien_grupp;


Select CreateSpatialIndex('tram_linien2','Geometry');
SELECT UpdateLayerStatistics('tram_linien2');

update tram_linien2
set
l1 = (case when linienliste like '% Linie 1:%' or linienliste like  'Linie 1:%' then 1 else 0 end),
l2 = (case when linienliste like '% Linie 2:%' or linienliste like  'Linie 2:%' then 1 else 0  end),
l3 = (case when linienliste like '% Linie 3:%' or linienliste like  'Linie 3:%' then 1 else 0  end),
l4 = (case when linienliste like '% Linie 4:%' or linienliste like  'Linie 4:%' then 1 else 0  end),
l5 = (case when linienliste like '% Linie 5:%' or linienliste like  'Linie 5:%' then 1 else 0  end),
l6 = (case when linienliste like '% Linie 6:%' or linienliste like  'Linie 6:%' then 1 else 0  end),
l7 = (case when linienliste like '% Linie 7:%' or linienliste like  'Linie 7:%' then 1 else 0  end),
l8 = (case when linienliste like '% Linie 8:%' or linienliste like  'Linie 8:%' then 1 else 0  end),
l9 = (case when linienliste like '% Linie 9:%' or linienliste like  'Linie 9:%' then 1 else 0  end),
l10 = (case when linienliste like '% Linie 10:%' or linienliste like  'Linie: 10%' then 1 else 0  end),
l11 = (case when linienliste like '% Linie 11:%' or linienliste like  'Linie 11:%' then 1 else 0  end),
l12 = (case when linienliste like '% Linie 12:%' or linienliste like  'Linie 12:%' then 1 else 0  end),
l13 = (case when linienliste like '% Linie 13:%' or linienliste like  'Linie 13:%' then 1 else 0  end),
l14 = (case when linienliste like '% Linie 14:%' or linienliste like  'Linie 14:%' then 1 else 0  end),
l15 = (case when linienliste like '% Linie 15:%' or linienliste like  'Linie 15:%' then 1 else 0  end),
l16 = (case when linienliste like '% Linie 16:%' or linienliste like  'Linie 16:%' then 1 else 0  end),
l17 = (case when linienliste like '% Linie 17:%' or linienliste like  'Linie 17:%' then 1 else 0  end),
l18 = (case when linienliste like '% Linie 18:%' or linienliste like  'Linie 18:%' then 1 else 0  end),
l19 = (case when linienliste like '% Linie 19:%' or linienliste like  'Linie 19:%' then 1 else 0  end),
l66 = (case when linienliste like '% Linie 66:%' or linienliste like  'Linie 66:%' then 1 else 0  end),
l67 = (case when linienliste like '% Linie 67:%' or linienliste like  'Linie 67:%' then 1 else 0  end)
;


update tram_linien2
set anzahl = (l1+l2+l3+l4+l5+l6+l7+l8+l9+l10+l11+l12+l13+l14+l15+l16+l17+l18+l19+l66+l67);

update tram_linien2
set li_liste = replace(
replace((l1||', '||(l2*2)||', '||(l3*3)||', '||(l4*4)||', '||(l5*5)||', '||(l6*6)||', '||(l7*7)||', '||(l8*8)||', '||(l9*9)||', '||(l10*10)||', '
||(l11*11)||', '||(l12*12)||', '||(l13*13)||', '||(l14*14)||', '||(l15*15)||', '||(l16*16)||', '||(l17*17)||', '||(l18*18)||', '||(l19*19)||', '||(l66*66)||', '||(l67*67) ),'0, ',''),
', 0','')
;

-- Spalten fü versatz


update tram_linien2
set
maximu = max(l1,l3*3,l4*4,l5*5,l7*7,l9*9,l12*12,l13*13,l15*15,l16*16,l17*17,l18*18,l66*66,l67*67),
minim = case when length(li_liste) >= 2 then substr(li_liste,1,(instr(li_liste,','))-1) else li_liste end,
mitte = case when anzahl = 4 then substr(li_liste,7,2) end;

--


--neu
-------------------
-------------------

create table stadtbahn as

select
a.ogc_fid as ogc_fid,
a.name as  nam,
a.railway as railway,
a.geometry as geometry
from lines as a inner join tramlinie_hae as b on st_intersects(a.geometry,b.geometry)

where   "railway" in ( 'tram','light_rail','rail')
   and  b.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='tramlinie_hae' AND search_frame=a.geometry);


Select RecoverGeometryColumn('stadtbahn','Geometry',25832,'linestring');
Select CreateSpatialIndex('stadtbahn','Geometry');
SELECT UpdateLayerStatistics('stadtbahn');

----

select ElementaryGeometries('stadtbahn','Geometry','stadtbahn_ele','pk_id','multi_id');

Select CreateSpatialIndex("stadtbahn_ele",'Geometry');


-------------

create table tram_attrib as
select distinct
a.geometry as geometry,
count(b.geometry) as anzahl,
group_concat(b.name,'; ') as linienliste
from stadtbahn_ele as a inner join tramlinie_hae as b on ST_Within(a.geometry,buffer(b.geometry,1))
where b.ROWID IN
            (SELECT ROWID FROM SpatialIndex WHERE f_table_name='tramlinie_hae' AND search_frame=a.geometry)
group by a.geometry
;

--
create table tramlinien_grupp as
select distinct
casttomultilinestring(gunion(geometry)) as geometry,
anzahl as anzahl,
linienliste as linienliste
from tram_attrib
group by linienliste
;
Select RecoverGeometryColumn('tramlinien_grupp','Geometry',25832,'MULTILINESTRING');
Select CreateSpatialIndex('tramlinien_grupp','Geometry');
SELECT UpdateLayerStatistics('tramlinien_grupp');





create table tram_linien(
fid INTEGER PRIMARY KEY AUTOINCREMENT,
anzahl integer (3),
linienliste varchar,
liniennr varchar,
l1 integer,
l2 integer,
l3 integer,
l4 integer,
l5 integer,
l6 integer,
l7 integer,
l8 integer,
l9 integer,
l10 integer,
l11 integer,
l12 integer,
l13 integer,
l14 integer,
l15 integer,
l16 integer,
l17 integer,
l18 integer,
l19 integer,
l66 integer,
l67 integer,
li_liste varchar,
maximu integer,
mitte integer,
minim integer,
geometry geometry)
;
Select RecoverGeometryColumn('tram_linien','Geometry',25832,'Multilinestring');

insert into tram_linien
(geometry,
anzahl,
linienliste)
select
geometry,
anzahl,
linienliste
from tramlinien_grupp;


Select CreateSpatialIndex('tram_linien','Geometry');
SELECT UpdateLayerStatistics('tram_linien');

update tram_linien
set
l1 = (case when linienliste like '% Linie 1:%' or linienliste like  'Linie 1:%' then 1 else 0 end),
l2 = (case when linienliste like '% Linie 2:%' or linienliste like  'Linie 2:%' then 1 else 0  end),
l3 = (case when linienliste like '% Linie 3:%' or linienliste like  'Linie 3:%' then 1 else 0  end),
l4 = (case when linienliste like '% Linie 4:%' or linienliste like  'Linie 4:%' then 1 else 0  end),
l5 = (case when linienliste like '% Linie 5:%' or linienliste like  'Linie 5:%' then 1 else 0  end),
l6 = (case when linienliste like '% Linie 6:%' or linienliste like  'Linie 6:%' then 1 else 0  end),
l7 = (case when linienliste like '% Linie 7:%' or linienliste like  'Linie 7:%' then 1 else 0  end),
l8 = (case when linienliste like '% Linie 8:%' or linienliste like  'Linie 8:%' then 1 else 0  end),
l9 = (case when linienliste like '% Linie 9:%' or linienliste like  'Linie 9:%' then 1 else 0  end),
l10 = (case when linienliste like '% Linie 10:%' or linienliste like  'Linie: 10%' then 1 else 0  end),
l11 = (case when linienliste like '% Linie 11:%' or linienliste like  'Linie 11:%' then 1 else 0  end),
l12 = (case when linienliste like '% Linie 12:%' or linienliste like  'Linie 12:%' then 1 else 0  end),
l13 = (case when linienliste like '% Linie 13:%' or linienliste like  'Linie 13:%' then 1 else 0  end),
l14 = (case when linienliste like '% Linie 14:%' or linienliste like  'Linie 14:%' then 1 else 0  end),
l15 = (case when linienliste like '% Linie 15:%' or linienliste like  'Linie 15:%' then 1 else 0  end),
l16 = (case when linienliste like '% Linie 16:%' or linienliste like  'Linie 16:%' then 1 else 0  end),
l17 = (case when linienliste like '% Linie 17:%' or linienliste like  'Linie 17:%' then 1 else 0  end),
l18 = (case when linienliste like '% Linie 18:%' or linienliste like  'Linie 18:%' then 1 else 0  end),
l19 = (case when linienliste like '% Linie 19:%' or linienliste like  'Linie 19:%' then 1 else 0  end),
l66 = (case when linienliste like '% Linie 66:%' or linienliste like  'Linie 66:%' then 1 else 0  end),
l67 = (case when linienliste like '% Linie 67:%' or linienliste like  'Linie 67:%' then 1 else 0  end)
;


update tram_linien
set anzahl = (l1+l2+l3+l4+l5+l6+l7+l8+l9+l10+l11+l12+l13+l14+l15+l16+l17+l18+l19+l66+l67);

update tram_linien
set li_liste = replace(
replace((l1||', '||(l2*2)||', '||(l3*3)||', '||(l4*4)||', '||(l5*5)||', '||(l6*6)||', '||(l7*7)||', '||(l8*8)||', '||(l9*9)||', '||(l10*10)||', '
||(l11*11)||', '||(l12*12)||', '||(l13*13)||', '||(l14*14)||', '||(l15*15)||', '||(l16*16)||', '||(l17*17)||', '||(l18*18)||', '||(l19*19)||', '||(l66*66)||', '||(l67*67) ),'0, ',''),
', 0','')
;



update tram_linien
set
maximu = max(l1,l3*3,l4*4,l5*5,l7*7,l9*9,l12*12,l13*13,l15*15,l16*16,l17*17,l18*18,l66*66,l67*67),
minimu = case when length(li_liste) >= 1 then substr(li_liste,1,(instr(li_liste,','))-1) else li_liste end,
mitte = case when anzahl = 4 then substr(li_liste,7,2) end;


-- Mitte definieren
alter table tram_linien2
add column tz1 integer;

alter table tram_linien2
add column tz2 integer;

alter table tram_linien2
add column tz3 integer;

alter table tram_linien2
add column tz4 integer;

update tram_linien2
set
tz1 = substr(li_liste,(instr(li_liste,',')+1));

update tram_linien2
set
tz2 = substr((tz1),(instr((tz1),', ')+ 1 ),10 );

update tram_linien2
set
tz3 = substr(tz1,1,instr(tz1,',')-1);


update tram_linien2
set
tz4 = substr(tz2,1,instr(tz2,',')-1);


update  tram_linien2
set mitte =
case 
when anzahl = 3 then tz3
when anzahl = 4 then tz4
end;



Select recoverSpatialIndex('tram_linien','Geometry');
SELECT UpdateLayerStatistics('tram_linien');

select dropgeotable('stadtbahn');
select dropgeotable('tram_attrib');
select dropgeotable('stadtbahn_ele');
select dropgeotable('tramlinien_grupp');
select dropgeotable('tramlinie_hae');

--trigger
--trigger  insert

CREATE TRIGGER t2_insert_1anz
AFTER INSERT
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
anzahl = (l1+l2+l3+l4+l5+l6+l7+l8+l9+l10+l11+l12+l13+l14+l15+l16+l17+l18+l19+l66+l67)
WHERE rowid = new.rowid;
END;

CREATE TRIGGER t2_insert_2liiste
AFTER INSERT
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
li_liste = replace(
replace((l1||', '||(l2*2)||', '||(l3*3)||', '||(l4*4)||', '||(l5*5)||', '||(l6*6)||', '||(l7*7)||', '||(l8*8)||', '||(l9*9)||', '||(l10*10)||', '
||(l11*11)||', '||(l12*12)||', '||(l13*13)||', '||(l14*14)||', '||(l15*15)||', '||(l16*16)||', '||(l17*17)||', '||(l18*18)||', '||(l19*19)||', '||(l66*66)||', '||(l67*67) ),'0, ',''),
', 0','')
WHERE rowid = new.rowid;
END;



--updatetrigger



CREATE TRIGGER t2_update_1anz
AFTER update of l1,l2,l3,l4,l5,l6,l7,l8,l9,l10,l11,l12,l13,l14,l15,l16,l17,l18,l19,l66,l67
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
anzahl = (l1+l2+l3+l4+l5+l6+l7+l8+l9+l10+l11+l12+l13+l14+l15+l16+l17+l18+l19+l66+l67)
WHERE rowid = new.rowid;
END;

CREATE TRIGGER t2_update_2liiste
AFTER update of anzahl
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
li_liste = replace(
replace((l1||', '||(l2*2)||', '||(l3*3)||', '||(l4*4)||', '||(l5*5)||', '||(l6*6)||', '||(l7*7)||', '||(l8*8)||', '||(l9*9)||', '||(l10*10)||', '
||(l11*11)||', '||(l12*12)||', '||(l13*13)||', '||(l14*14)||', '||(l15*15)||', '||(l16*16)||', '||(l17*17)||', '||(l18*18)||', '||(l19*19)||', '||(l66*66)||', '||(l67*67) ),'0, ',''),
', 0','')
WHERE rowid = new.rowid;
END;

CREATE TRIGGER t2_update_3max
AFTER update of li_liste
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
maximu = max(l1,l3*3,l4*4,l5*5,l7*7,l9*9,l12*12,l13*13,l15*15,l16*16,l17*17,l18*18,l66*66,l67*67)
WHERE rowid = new.rowid;
END;

CREATE TRIGGER t2_update_4minimu
AFTER update of li_liste
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
minimu =  case when li_liste like '%,%'  then substr(li_liste,1,(instr(li_liste,','))-1) else li_liste end
WHERE rowid = new.rowid;
END;


---
CREATE TRIGGER t2_update_5t1
AFTER update of li_liste
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
tz1 = substr(li_liste,(instr(li_liste,',')+1))
WHERE rowid = new.rowid;
END;

CREATE TRIGGER t2_update_6t2
AFTER update of tz1
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
tz2 = substr((tz1),(instr((tz1),', ')+ 1 ),10 )
WHERE rowid = new.rowid;
END

drop TRIGGER t2_update_7t3;
CREATE TRIGGER t2_update_7t3
AFTER update of tz2
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
tz3 = substr(tz1,1,instr(tz1,',')-1)
WHERE rowid = new.rowid;
END;

CREATE TRIGGER tz2_update_8t4
AFTER update of tz3
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
tz4 = substr(tz2,1,instr(tz2,',')-1)
WHERE rowid = new.rowid;
END;


CREATE TRIGGER t2_update_9mitte
AFTER update of tz4,tz3
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  
SET 
mitte = case when anzahl = 3 then tz3 when anzahl = 4 then tz4 end
WHERE rowid = new.rowid;
END;


---------------ende















CREATE TRIGGER t2_LIST
AFTER INSERT
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  set 
li_liste = replace(
replace((l1||', '||(l2*2)||', '||(l3*3)||', '||(l4*4)||', '||(l5*5)||', '||(l6*6)||', '||(l7*7)||', '||(l8*8)||', '||(l9*9)||', '||(l10*10)||', '
||(l11*11)||', '||(l12*12)||', '||(l13*13)||', '||(l14*14)||', '||(l15*15)||', '||(l16*16)||', '||(l17*17)||', '||(l18*18)||', '||(l19*19)||', '||(l66*66)||', '||(l67*67) ),'0, ',''),
', 0',''),
maximu = max(l1,l3*3,l4*4,l5*5,l7*7,l9*9,l12*12,l13*13,l15*15,l16*16,l17*17,l18*18,l66*66,l67*67),
minimu = case when length(li_liste) >= 1 then substr(li_liste,1,(instr(li_liste,','))-1) else li_liste end,
tz1 = substr(li_liste,(instr(li_liste,',')+1)),
tz2 = substr((tz1),(instr((tz1),', ')+ 1 ) ),
tz3 = substr(tz1,1,instr(tz1,',')-1),
tz4 = substr(tz2,1,instr(tz2,',')-1),
mitte = case when anzahl = 3 then tz3 when anzahl = 4 then tz4 end
WHERE rowid = new.rowid;
END;


CREATE TRIGGER t2_LISTUP
AFTER update of l1,l2,l3,l4,l5,l6,l7,l8,l9,l10,l11,l12,l13,l14,l15,l16,l17,l18,l19,l66,l67
ON 'tram_linien2' for each row
begin
Update 'tram_linien2'  set 
li_liste = replace(
replace((l1||', '||(l2*2)||', '||(l3*3)||', '||(l4*4)||', '||(l5*5)||', '||(l6*6)||', '||(l7*7)||', '||(l8*8)||', '||(l9*9)||', '||(l10*10)||', '
||(l11*11)||', '||(l12*12)||', '||(l13*13)||', '||(l14*14)||', '||(l15*15)||', '||(l16*16)||', '||(l17*17)||', '||(l18*18)||', '||(l19*19)||', '||(l66*66)||', '||(l67*67) ),'0, ',''),
', 0',''),
maximu = max(l1,l3*3,l4*4,l5*5,l7*7,l9*9,l12*12,l13*13,l15*15,l16*16,l17*17,l18*18,l66*66,l67*67),
minimu = case when length(li_liste) >= 1 then substr(li_liste,1,(instr(li_liste,','))-1) else li_liste end,
tz1 = substr(li_liste,(instr(li_liste,',')+1)),
tz2 = substr((tz1),(instr((tz1),', ')+ 1 ) ),
tz3 = substr(tz1,1,instr(tz1,',')-1),
tz4 = substr(tz2,1,instr(tz2,',')-1),
mitte = case when anzahl = 3 then tz3 when anzahl = 4 then tz4 end
WHERE rowid = new.rowid;
END;

-----------


------------------
----------------

--funktioniert nicht
case
when "anzahl" = 4 then

	(Case
	when "l4" * 4 =  max(  "li_liste" ) then 12
	when  "l4" * 4 =   max(replace( "li_liste" ,', '||max(  "li_liste" ),'')) then 8
	when "l4" * 4 =    max(replace( replace( "li_liste" ,', '||max(  "li_liste" ),'') ,', '||max(  "li_liste" ),'')) then 4
	else 0 end)


when "anzahl" = 3 then

	(Case
	when "l4" * 4 =  max(  "li_liste" ) then 8
	when "l4" * 4 =   max(replace( "li_liste" ,', '||max(  "li_liste" ),'')) then 4
	else 0 end)

when "anzahl" = 2 then

	(Case
	when "l4" * 4 =  max(  "li_liste" ) then 4
	else 0 end)
	
when  "anzahl" = 1  then 0
	 
end




--geometrien in SpatiaLite
Select RecoverGeometryColumn('tabelle','Geometry',25832,'POLYGON');
Select CreateSpatialIndex('tabelle','Geometry');
SELECT UpdateLayerStatistics('gabelle');
