#!/bin/bash

#wget https://download.geofabrik.de/europe/germany-latest.osm.pbf
#wget http://download.geofabrik.de/europe/germany/hessen-latest.osm.pbf
#wget https://download.geofabrik.de/europe-latest.osm.pbf
raum="5.2866889 46.9679949 16.0630369 55.3034596"

for pbfs in *.pbf ; do

# Spatialite
#lines
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln fluss_linien -update -append -spat $raum  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures gewaesser_osm.sqlite $pbfs -sql "select name,waterway,width as breite,CEMT, cast(ref_fgkz as integer) from lines where  waterway in ('river','riverbank')" 

#pols
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832  -nln fluss_flaechen -update -append -spat $raum  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures gewaesser_osm.sqlite $pbfs -sql "select name,water,waterway from multipolygons where  waterway in ('river','riverbank') or water = 'river'"

#spatialite -silent gewaesser_osm.sqlite "
#delete from spatial_ref_sys_aux where srid  not in (select srid from geometry_columns);
#delete from spatial_ref_sys where srid  not in (select srid from geometry_columns);"

#Geopackage
#lines
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f GPKG -nln fluss_linien -update -append -spat $raum  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures gewaesser_osm.gpkg $pbfs -sql "select name,waterway,width as breite,CEMT, cast(ref_fgkz as integer) as ref_fgkz ,ref from lines where  waterway in ('river','riverbank')" 
# destination
# (case when name in ('Donau','Rhein','Elbe','Oder','Weser','Mosel','Main','Inn','Saale','Spree','Ems','Neckar','Havel','Eger','Werra','Isar','Mulde','Fulda','Ruhr','Lippe','Altmühl','Salzach','Saar','Lahn','Weiße Elster','Aller','Lech','Leine') or name like '%Rhein%' then 1 else 0 end ) as strom , destination 

#pols
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f GPKG -nln fluss_flaechen -update -append  -spat $raum -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures gewaesser_osm.gpkg $pbfs -sql "select name,water,waterway from multipolygons where  waterway in ('river','riverbank') or water = 'river'"

#mult
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f GPKG -nln fluss_relationen -update -append -spat $raum  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures gewaesser_osm.gpkg $pbfs -sql "select name,type,network,ref,destination,ref_fgkz,length from multilinestrings where type = 'waterway' or waterway = 'river'"

done
spatialite -silent gewaesser_osm.gpkg "
alter table fluss_linien
add column strom integer;

update fluss_linien
set
strom =
(case when name in ('Donau','Rhein','Elbe','Oder','Weser','Mosel','Main','Inn','Saale','Spree','Ems','Neckar','Havel','Eger','Werra','Isar','Mulde','Fulda','Ruhr','Lippe','Altmühl','Salzach','Saar','Lahn','Weiße Elster','Aller','Lech','Leine') or name like '%Rhein%' then 1 else 0 end )
;
"
