#!/bin/bash
#-spat 8.81165611 51.44055321 9.66843627 51.93188901
#-spat 551537 5984753 578712 6001370 -spat_srs EPSG:25832 -progress
read -p "Namen der resultierenden SQLITE-Datenbank ohne Dateiendung eingeben und return drücken:   " db
echo
echo
#read -p "Namen der OSM-Datei eingeben   " osm

echo
#echo Koordinaten des Ausschnitts angeben, wenn alles importiert werden soll n eingeben
echo
echo
#read -p "Koordinaten des Gebiets eingeben in der Form xmin ymin xmax ymax oder n:   " raum 
echo

#+raum="7.585308473577312 51.609717016887245 8.339036176916325 52.15103054928527"
echo
echo
#if [ "$raum" = "n" ]; then
#raum="3.7 47 17.1 55.5"
#raum="10.015180245830955 49.04460500567298 10.82771267093855 49.59715260608027"
#fi
for pbfs in *.pbf; do
#pointd
ogr2ogr --config OGR_INTERLEAVED_READING YES  --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln points -update -append -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,place,highway,addr_housenumber,parking,information,public_transport,generator,leisure,amenity,tourism,shop,craft,healthcare,building,wheelchair,shelter,population  from points"
#--where information is not null or place is not NULL or leisure is not null or amenity is not null or office is not null or tourism is not null or shop is not null or craft is not null  or building is not null or addr_housenumber is not null or highway is not null or public_transport is not NULL or  healthcare is not null or social_facility is not null

ogr2ogr --config OGR_INTERLEAVED_READING YES   --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln places -update -append -gt unlimited   -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,place,population from points where place is not NULL or place <> ''"

#lines
ogr2ogr --config OGR_INTERLEAVED_READING YES   --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln lines -update -append  -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,highway,cycleway,railway,bridge,tunnel,ref,oneway,sidewalk,tracktype,waterway,power from lines where highway is not null or railway is not null or waterway is not null or power is not null" 

ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf2.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832  -nln pols -update -append  -gt unlimited    -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,landuse,industrial,building,admin_level,postal_code from multipolygons"

#pols
ogr2ogr --config OGR_INTERLEAVED_READING YES   --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln multipolygons -update -append  -gt unlimited   -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,landuse,natural,waterway,leisure,amenity,man_made,place,aeroway,building,addr_housenumber,postal_code,admin_level from multipolygons"
#-- where building is not NULL OR landuse is not null OR natural is not null OR waterway is not null OR leisure is not null OR amenity is not null OR man_made is not null OR place is not null OR aeroway is not null or admin_level is not null or addr_housenumber is not null or length(postal_code) > 0 
#multilines -dialect sqlite 
ogr2ogr --config OGR_INTERLEAVED_READING YES --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -geomfield geometry -nln multilinestrings -update -append  -gt unlimited   -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select * from multilinestrings"

ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832  -update -nln kraftwerk -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832  $db.sqlite $pbfs -sql "select name,power,voltage,generator_method,generator_source,generator_output_electricity,cast(height_hub as integer(3)) as nabenhoehe,cast(height as integer(3)) as hoehe from points where power = 'generator'"

#routing fahrzeuge
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln tbl_routing_fahrzeug -update -append -gt unlimited -spat $raum -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,highway,bridge,tunnel,ref,oneway from lines where highway in ( 'secondary' , 'secondary_link',  'tertiary' , 'primary' , 'primary_link', 'trunk', 'trunk_link', 'motorway' , 'motorway_link','residential' , 'road','unclassified','living_street')"
#Routing_Fuss
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln tbl_routing_fussgaenger -update -append  -gt unlimited -spat $raum -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,highway,bridge,tunnel,ref,sidewalk from lines where highway in ('bridleway','cycleway','footway','living_street','path','pedestrian','primary','primary_link','proposed','razed','residential','secondary','secondary_link','steps','tertiary','tertiary_link','track','unclassified','road','service')" 2> meldungen_fu.txt

# Kraftwerke
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nln kraftwerke  -gt unlimited -update -append   -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,generator,generator_source,generator_method,generator_output_electricity,cast(height_hub as integer(3)) as nabenhoehe,cast(height as integer(3)) as hoehe from points where power = 'generator' or generator is not null"

#Leitungen
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -update -append  -nln leitungen -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $pbfs -sql "select name,type,man_made,power,voltage,cables,substance from lines where power in ('line','minor_line') or man_made = 'pipeline'"

done


#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 2048 --config OSM_MAX_TMPFILE_SIZE 2000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -append -nln strassen -gt unlimited -spat 9.21872758185 51.1469590982 9.80027669203 51.4821209721 -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures nie.sqlite n.pbf -sql "select name,highway,ref from lines where highway in('motorway', 'motorway_link', 'trunk', 'trunk_link', 'primary','primary_link','secondary','secondary_link')"
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 2048 --config OSM_MAX_TMPFILE_SIZE 2000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -append -nln eisenbahnen -gt unlimited -spat 9.21872758185 51.1469590982 9.80027669203 51.4821209721 -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures nie.sqlite n.pbf -sql "select name,type,railway from lines where railway is not null"
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 2048 --config OSM_MAX_TMPFILE_SIZE 2000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -append -nln landschaft -gt unlimited -spat 9.21872758185 51.1469590982 9.80027669203 51.4821209721 -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures nie.sqlite n.pbf -sql "select name,landuse,natural,waterway from multipolygons where landuse in ('farmland','forest','meadow','orchard') or natural in ('wood', 'scrub','heath','moor','grassland','bare_rock','sand','wetland','water','beach') or waterway is not null"
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -update -nln lkr -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm-s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,admin_level,boundary from multipolygons where boundary is not null and ( admin_level = '6' or (admin_level = '4' and name in ('Hamburg','Berlin','Bremen'))) order by admin_level asc"

spatialite -silent $db.sqlite < spalten_anlegen.sql
