#!/bin/bash
#-spat 7.53019822955 51.1619663471 7.72187899649 51.2652623188
#-spat 551537 5984753 578712 6001370 -spat_srs EPSG:25832 -progress
echo
echo
read -p "Namen der resultierenden SQLITE-Datenbank ohne Dateiendung eingeben und return drücken:   " db
echo
echo
read -p "Namen der OSM-Datei eingeben   " osm

echo
#echo Koordinaten des Ausschnitts angeben, wenn alles importiert werden soll n eingeben
echo
echo
# read -p "Koordinaten des Gebiets eingeben in der Form xmin ymin xmax ymax oder n:   " raum 
echo
echo
# -spat $raum
# if [ "$raum" = "n" ]; then
# raum="3.7 47 17.1 55.5"
# fi
echo
echo
echo Linien Import
echo
echo
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -nln linien  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,highway,railway,waterway,usage from lines where highway in ('motorway','motorway_link','trunk','trunk_link','primary','primary_link','secondary','secondary_link') or railway = 'rail' or waterway in ('river','canal')" 
echo
echo
echo wka Import
echo
echo
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -update -nln wka -gt unlimited -skipfailures -s_srs EPSG:4326 -t_srs EPSG:25832 $db.sqlite $osm -sql "select name,ref,offshore,operator as betreiber,manufacturer as hersteller,manufacturer_type as fabrikat,start_date as in_betrieb_seit, cast(voltage as integer) as spannung,generator_method as methode,generator_source as quelle,generator_type as typ,generator_output_electricity as leistung,generator_output as leistung2,cast(rotor_diameter as integer(3)) as rotor_durchmesser,cast(height_hub as integer(3)) as nabenhoehe,cast(height as integer(3)) as hoehe from points where power = 'generator' and (generator_source like '%wind%' or generator_method like '%wind%')"
echo
echo
echo Punkt Import
echo
echo
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -update -nln punkte  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,place,railway,CAST(population AS integer(7)) from points where place is not null OR railway in('station','halt')" 
echo
echo
echo Grenzen Import
echo
echo
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -update -nln grenzen -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,admin_level,postal_code,boundary from multipolygons where admin_level is not NULL or postal_code is not NULL"
echo
echo
echo
echo Industrie Import
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -update -nln industrie -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,industrial from multipolygons where landuse = 'industrial'"
echo
echo
echo Leitungen Import
echo
echo
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -update -nln leitungen -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,type,man_made,power,voltage,cables from lines where power in ('line','minor_line')"
echo
echo
echo Gewässer Import
echo
echo
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -update -nln gewaesser -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name, landuse, natural, waterway, amenity from multipolygons where waterway = 'riverbank' or natural IN ( 'reservoir' , 'riverbank' , 'water' , 'waterway'  )"

#multilines
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -nln multilinestrings -update -gt unlimited -spat $raum  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select * from multilinestrings "

#routing fahrzeuge
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -nln tbl_routing_fahrzeug -update -gt unlimited -spat $raum -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,highway,bridge,tunnel,ref,oneway from lines where highway in ( 'secondary' , 'secondary_link',  'tertiary' , 'primary' , 'primary_link', 'trunk', 'trunk_link', 'motorway' , 'motorway_link','residential' , 'road','unclassified','living_street')"
#Routing_Fuss
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -nln tbl_routing_fussgaenger -update -gt unlimited -spat $raum -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,highway,bridge,tunnel,ref,sidewalk from lines where highway in ('bridleway','cycleway','footway','living_street','path','pedestrian','primary','primary_link','proposed','razed','residential','secondary','secondary_link','steps','tertiary','tertiary_link','track','unclassified','road','service')" 2> meldungen_fu.txt

# Kraftwerke
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -nln kraftwerke  -gt unlimited -update -spat $raum  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,generator,generator_source,generator_method,generator_output_electricity,cast(height_hub as integer(3)) as nabenhoehe,cast(height as integer(3)) as hoehe from points where power = 'generator' or generator is not null"




#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 2048 --config OSM_MAX_TMPFILE_SIZE 2000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -append -nln strassen -gt unlimited -spat 9.21872758185 51.1469590982 9.80027669203 51.4821209721 -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures nie.sqlite n.pbf -sql "select name,highway,ref from lines where highway in('motorway', 'motorway_link', 'trunk', 'trunk_link', 'primary','primary_link','secondary','secondary_link')"
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 2048 --config OSM_MAX_TMPFILE_SIZE 2000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -append -nln eisenbahnen -gt unlimited -spat 9.21872758185 51.1469590982 9.80027669203 51.4821209721 -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures nie.sqlite n.pbf -sql "select name,type,railway from lines where railway is not null"
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 2048 --config OSM_MAX_TMPFILE_SIZE 2000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -append -nln landschaft -gt unlimited -spat 9.21872758185 51.1469590982 9.80027669203 51.4821209721 -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures nie.sqlite n.pbf -sql "select name,landuse,natural,waterway from multipolygons where landuse in ('farmland','forest','meadow','orchard') or natural in ('wood', 'scrub','heath','moor','grassland','bare_rock','sand','wetland','water','beach') or waterway is not null"
#ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_CONFIG_FILE osmconf.ini --config OSM_COMPRESS_NODES YES  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -lco COMPRESS_GEOM=YES -update -nln lkr -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm-s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm -sql "select name,admin_level,boundary from multipolygons where boundary is not null and ( admin_level = '6' or (admin_level = '4' and name in ('Hamburg','Berlin','Bremen'))) order by admin_level asc"

#spatialite -silent $db.sqlite.sqlite < abfragen.sql
