﻿cls
cls
@echo off
:: Codepage auf utf-8 setzen
chcp 65001
cls
echo.
echo  *****************************************************************************
echo  *                                                                           *
echo  *  OSM-PBF-Dateien mit ogr2ogr nach PostGis importieren                     *
echo  *  Spalten für die Symbolisierung im QGIS anlegen                           *
echo  *  Fragen und Support:                                                      *
echo  *                                                                           *
echo  *  GKG Dr.-Ing. Claas Leiner                                                *
echo  *  http://www.gkg-kassel.de                                                 *
echo  *  claas.leiner@gkg-kassel.de                                               *
echo  *                                                                           *
echo  *****************************************************************************
echo.
:: Die üblichen QGIS-Installationspfade für qgis 3.4 2.18 und gis 2.14  werden nacheinander geprüft
echo  **************************************************************************
echo Testen in welchem Verzeichnis sich die QGIS-Installation befindet

setlocal enableextensions
::pfad zum Skript ermitteln
set "scriptp=%~dp0"
::in Skript-Ordner wechseln
cd "%~dp0"
::Laufwerk wechseln
%~d0
echo ***************************************************************
echo Testen in welchem Verzeichnis sich die QGIS-Installation befindet


::QGIS suchen
for /d %%d in ( "C:\OSGeo*" "C:\Program Files\QGIS 3*"  "C:\Program Files (x86)\QGIS 3*" "C:\Programme (x86)\QGIS 3*"  "C:\Programme\QGIS 3*" ) do call :checkQGIS "%%d"


::Nicht gefunden
::if "%ogrp%"=="" goto qf
::gefunden
::goto start

:checkQGIS
::echo.check %~1
if exist "%~1\bin\ogr2ogr.exe" set "ogrp=%~1"
::Nicht gefunden
if "%ogrp%"=="" goto qf
::goto :eof
goto start

    :qf
    echo.
    echo.
    set inst=nein
    echo ***************************************************************
    echo QGIS scheint nicht an einem üblichen Ort installiert zu sein?
    set /p inst="Ist QGIS installiert? ja oder nein? "
    if %inst%==nein goto wars
    echo Geben Sie den Pfad Ihrer QGIS-Installation ein:
    echo.
    set /p ogrp="Bitte vollen Pfad der QGIS-Installation eingeben: "
    set path=%path%;%ogrp%\bin;%scriptp%
    goto start
    :wars
    echo Skript wird abgebrochen - Bitte  QGIS installieren
    pause
    exit
    :start
    set "path=%path%;%ogrp%\bin\;%scriptp%"


echo.
echo ***************************************************************
echo QGIS ist installiert unter %ogrp%
echo  ***************************************************************
:: Im folgenden können die notwendigen Datenbankvariablen interaktiv eingegeben werden
:: Alternativ findet sich, - auskommentiert - für jede Variable eine Zeile,
:: in der sich der jeweilige Wert fest eintragen lässt, so dass dieses Skript auch ohne
:: interaktive Eingabe läuft:
:: Einfach die set /p Zeilen auskommentieren und die set variable=wert Zeilen mit
:: Inhalt füllen und aktiv setzen
echo.

::set grenze=public
::Variable fuer das Datenbankschema setzen
set /p grenze=" Name des Shapefiles mit den Import-Grenzen oder RETURN "
echo.

if "%grenze%"=="" goto qff
goto vorwaerts
:qff
::Variable fuer die räumliche Ausdehnung
set /p raum=" Koordinaten des Gebiets eingeben in der Form xmin ymin xmax ymax oder ges für alles: "
echo.
if %raum%==ges goto abr
goto vorwaerts
:abr
set raum="3.7 47 17.1 55.5"
:vorwaerts

set sch=public
::Variable fuer das Datenbankschema setzen
set /p sch=" DB-Schema-Name eingeben, wenn benutzerdefiniertes Schema vorliegt und return drücken: "
::Alternative
::set sch="osm"
echo.

::Variable fuer den Namen der resultierenden Datenbank setzen
set /p dab=" Name der Ziel-Datenbank eingeben und RETURN drücken: "
::Alternative
::set dab="datenbankname"
echo.

::Variable fuer den Benutzernamen
set /p us=" Benutzername eingeben und RETURN druecken: "
::Alternative
::set us="postgres"
echo.

::Variable fuer das Passwort setzen
set /p pw=" Passwort eingeben und RETURN druecken: "
::Alternative
::set pw="passwort"
echo.

::Variable fuer den Rechnernamen
set rec=localhost
set /p rec=" Wenn nicht lokal Rechnername oder ip eingeben und RETURN druecken: "
::Alternative
::set rec="a610wdb0009"
echo.

::Variable fuer den Port
set port=5432
set /p port=" Portnummer eingeben wenn nicht 5432 und RETURN druecken: "
::Alternative
::set rec="5432"
echo.


echo "dbname='%dab%' host='%rec%' schemas=%sch% port='%port%' user='%us%' password='%pw%'"
echo.
echo  ***************************************************************-
echo  In welchem Verzeichnis liegen Ihre PBF-Dateien?
echo  Vollständigen Verzeichnispfad eingeben und RETURN drücken 
echo.
set /p pfadpbf="Bitte Pfad eingeben oder via rechte Maustaste aus der Zwischenablage einfügen: "
::Alternative
::set pfadpbf="C:\pfaszudendateien"
echo  ***************************************************************
echo.
echo  Ihre Daten liegen in %pfadpbf%
echo.
echo  ***************************************************************
echo.
:: osmonf.ini wird in das PBF-Verzeichnis kopiert
copy "%HOMEDRIVE%%HOMEPATH%\gkg\osmconf.ini" "%pfadpbf%\osmconf.ini"
copy "%HOMEDRIVE%%HOMEPATH%\gkg\spalten_anlegen.sql" "%pfadpbf%\spalten_anlegen.sql"
:: Verzeichniswechsel in das verzeichnis mit der PBF-datei
pushd "%pfadpbf%"

dir /B *.pbf > liste.txt
set /p pliste= < liste.txt
echo.
echo  %pliste%
echo.
echo  wird in die Datenbank %dab% importiert
echo.
echo.
set PGPASSWORD=%pw%
psql.exe --host="%rec%" --port="%port%" --dbname="%dab%" --username="%us%"  -c "drop table if exists %sch%.tbl_poi;"
psql.exe --host="%rec%" --port="%port%" --dbname="%dab%" --username="%us%"  -c "drop table if exists %sch%.tbl_linien;"
psql.exe --host="%rec%" --port="%port%" --dbname="%dab%" --username="%us%"  -c "drop table if exists %sch%.tbl_landuse;"
psql.exe --host="%rec%" --port="%port%" --dbname="%dab%" --username="%us%"  -c "drop table if exists %sch%.multilinestrings;"
psql.exe --host="%rec%" --port="%port%" --dbname="%dab%" --username="%us%"  -c "drop table if exists %sch%.tbl_hnr"


echo.
echo ***************************************************************
echo.
echo %grenze%

pause
:: Über eine for-Schleife werden alle pbf-dateien eines Verzeichnisse importiert
:: ogr2ogr importiert über eine integrierte SQL-Abfrage die benötigent Inhhalte und legt diese in die über -nln definierten Layer
if "%grenze%"=="" goto or

ogr2ogr  -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OSM_CONFIG_FILE osmconf.ini  --config PG_USE_COPY YES   -f PostgreSQL PG:"dbname='%dab%' host='%rec%' schemas=%sch% port='%port%' user='%us%' password='%pw%'" -lco GEOMETRY_NAME=geom -nln rahmen -overwrite -gt unlimited -a_srs EPSG:25832 -skipfailures  %grenze%

psql.exe --host="%rec%" --port="%port%" --dbname="%dab%" --username="%us%" -A -t -z -0 --output=ext.txt -c "select replace(substr(ST_Extent(st_transform(geom,4326))::text,5,(strpos(ST_Extent(st_transform(geom,4326))::text,')') ) -5),',',' ') from %sch%.rahmen"
::  > ext.txt
::setlocal enabledelayedexpansion
::for /F %%x in (ext.txt) do (set exte=%%x)

::echo "!exte!"
::set "raum=!exte!"
::endlocal
set /p axte= < ext.txt
echo %axte%
set raum=%axte%
:or
echo %raum%
pause

for %%x in (*.pbf) do (

::Poi
echo.
Echo Poi wird importiert
ogr2ogr  -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OSM_CONFIG_FILE osmconf.ini  --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES  -f PostgreSQL PG:"dbname='%dab%' host='%rec%' schemas=%sch% port='%port%' user='%us%' password='%pw%'" -nln tbl_poi -overwrite -gt unlimited -spat '%raum%' -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures "%%x" -sql "select name,place,addr_housenumber,leisure,amenity,office,tourism,shop,craft,healthcare,social_facility,building  from points where leisure is not null or amenity is not null or office is not null or tourism is not null or shop is not null or craft is not null or healthcare is not null or social_facility is not null or building is not null or addr_housenumber is not null" 2> meldungen_poi.txt
echo.

::Linien
echo Linien werden importiert
ogr2ogr  -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OSM_CONFIG_FILE osmconf.ini  --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES  -f PostgreSQL PG:"dbname='%dab%' host='%rec%' schemas=%sch% port='%port%' user='%us%' password='%pw%'" -nln tbl_linien -overwrite -gt unlimited -spat '%raum%' -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures "%%x" -sql "select name,highway,tracktype,railway,bridge,tunnel,ref,oneway,sidewalk,waterway,power from lines where highway is not null or railway is not null or waterway is not null or power is not null"  2> meldungen_stra.txt
echo.

::Nutzung
echo Nutzung wird importiert
ogr2ogr  -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OSM_CONFIG_FILE osmconf.ini  --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES  -f PostgreSQL PG:"dbname='%dab%' host='%rec%' schemas=%sch% port='%port%' user='%us%' password='%pw%'" -nln tbl_landuse -overwrite -gt unlimited -spat '%raum%'  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures "%%x" -sql "select name,landuse,natural,waterway,leisure,amenity,man_made,place,aeroway,building,addr_housenumber,postal_code,admin_level from multipolygons where building is not NULL OR landuse is not null OR natural is not null OR waterway is not null OR leisure is not null OR amenity is not null OR man_made is not null OR place is not null OR aeroway is not null or admin_level is not null or addr_housenumber is not null or postal_code is not null" 2> meldungen_nu.txt
echo.

::multilinien
ogr2ogr  -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OSM_CONFIG_FILE osmconf.ini  --config PG_USE_COPY YES --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES  -f PostgreSQL PG:"dbname='%dab%' host='%rec%' schemas=%sch% port='%port%' user='%us%' password='%pw%'" -nln multilinestrings -overwrite -gt unlimited -spat '%raum%'  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures "%%x" -sql "select * from multilinestrings "
) 

echo.
echo ******************************************************************
:: Wenn die folgenden Textdateien nicht vorhanden sind, gab es bei den entsprechenden Layern ein Importproblem
echo.
if not exist "%pfadpbf%\meldungen_stra.txt" goto impfehler
if not exist "%pfadpbf%\meldungen_nu.txt" goto impfehler
if not exist "%pfadpbf%\meldungen_poi.txt" goto impfehler

echo.
echo ******************************************************************
echo Daten sind erolgreich in die Datenbank %dab% auf %rec% importiert
goto fertig

:impfehler
echo.
echo ******************************************************************
echo Der Import eines oder mehrerer Layer ist fehlgeschlagen
goto end
:fertig
echo.
echo ******************************************************************
echo SQL-Skript zum Anlegen der für die Symbolsierung im QGIS notwendigen Spalten startet
echo.
echo Die für die regelbasierte Symbolisierungen notwendigen Abfragen werden jetzt von PostGis umgesetzt,
echo so dass QGIS nur noch 1 oder 0 aus den neuen Spalten lesen muss.
echo.
echo PgPasswword als Umgebungsvariable setzen, damit es nicht eingegeben werden muss
set PGPASSWORD=%pw%
::SQL-Skript wird aufgerufen
::"C:\Program Files\QGIS 2.18\bin\psql.exe" --host="%rec%" --port="5432" --dbname="%dab%" --username="%us%" --password --file="%HOMEDRIVE%%HOMEPATH%\Desktop\gkg\spalten_anlegen.sql"
::psql --host="%rec%" --port="5432" --dbname="%dab%" --username="%us%" --password --file="%HOMEDRIVE%%HOMEPATH%\Desktop\gkg\spalten_anlegen.sql"
::Funktioniert:
psql.exe --host="%rec%" --port="%port%" --dbname="%dab%" --username="%us%" --file="spalten_anlegen.sql"
echo.
echo ***************************************	***************************
echo Wenn es keine Fehlermeldungen gibt, sollten die notwendigen Spalten angelegt worden sein
pause
exit
:end
pause
