﻿cls
cls
@echo off
:: Codepage auf utf-8 setzen
chcp 65001
cls
echo.
echo  *****************************************************************************
echo  *                                                                           *
echo  *  OSM-PBF-Datei mit ogr2ogr nach Sqlite importieren                       *
echo  *  Spalten für die Symbolisierung im QGIS anlegen                           *
echo  *                                                                           *
echo  *  Fragen und Support:                                                      *
echo  *                                                                           *
echo  *  GKG Dr.-Ing. Claas Leiner                                                *
echo  *  http://www.gkg-kassel.de                                                 *
echo  *  claas.leiner@gkg-kassel.de                                               *
echo  *                                                                           *
echo  *****************************************************************************
echo.

echo  **************************************************************************

setlocal enableextensions
::pfad zum Skript ermitteln
set "scriptp=%~dp0"
::in Skript-Ordner wechseln
cd "%~dp0"
::Laufwerk wechseln
%~d0
echo ***************************************************************
echo Testen in welchem Verzeichnis sich die QGIS-Installation befindet


::QGIS suchen
for /d %%d in ( "C:\Program Files\QGIS 3.16*" "C:\Program Files\QGIS 3*"  "C:\Program Files (x86)\QGIS 3*" "C:\Programme (x86)\QGIS 3*"  "C:\Programme\QGIS 3*" "C:\OSGeo*" ) do call :checkQGIS "%%d"


:checkQGIS
::echo.check %~1
if exist "%~1\bin\ogr2ogr.exe" set "ogrp=%~1"
::Nicht gefunden
if "%ogrp%"=="" goto qf
::goto :eof
goto start

    :qf
    echo.
    echo.
    set inst=nein
    echo ***************************************************************
    echo QGIS scheint nicht an einem üblichen Ort installiert zu sein?
    set /p inst="Ist QGIS installiert? ja oder nein? "
    if %inst%==nein goto wars
    echo Geben Sie den Pfad Ihrer QGIS-Installation ein:
    echo.
    set /p ogrp="Bitte vollen Pfad der QGIS-Installation eingeben: "
    set path=%path%;%ogrp%\bin;%scriptp%
    goto start
    :wars
    echo Skript wird abgebrochen - Bitte  QGIS installieren
    pause
    exit
    :start
    set "path=%path%;%ogrp%\bin\;%scriptp%"


echo.
echo ***************************************************************
echo QGIS ist installiert unter %ogrp%
echo  ***************************************************************
echo.


:ogr
if not exist "%ogrp%\ogr2ogr.exe" goto ogi1
goto ogrp
:ogi1
if not exist "%ogrp%\bin\ogr2ogr.exe" goto og
:ogrp
echo ogr2ogr ist installiert

:: test ob die notwendigen Programme vorhanden sind

goto eing
:og
echo.
echo ogr2ogr ist nicht installiert
echo Das Skript wird nicht funktionieren.
echo Haben Sie qgis ordnungsgemäß installiert?
echo Dann sollte ogr2ogr auch installiert sein.
echo.
:abr
echo Das Skript wird wegen fehlender Abhängigkeiten abgebrochen
pause
exit

:eing


echo.
:: Neu 2019-12-01 Setzen der Umgebungsvariablen
SET GDAL_DATA=%ogrp%\share\gdal
SET GDAL_DRIVER_PATH=%ogrp%\bin\gdalplugins
SET PROJ_LIB=%ogrp%\share\proj


::set /p db="Namen der resultierenden SQlite-Datei ohne Endung eingeben: " 
set db=osm
::echo.
::echo Koordinaten des Ausschnitts angeben, wenn alles importiert werden soll n eingeben:
::echo.
:: raum=7.078818 48.92085 10.32531 49.92662
echo.
:: echo Koordinatenrahmen:  %raum%
echo.
echo  ***************************************************************-
echo  In welchem Verzeichnis liegen Ihre PBF-Dateien?
echo  Vollständigen Verzeichnispfad eingeben und RETURN drücken 
echo.
set /p pfadpbf="Bitte Pfad eingeben oder via rechte Maustaste aus der Zwischenablage einfügen: "

echo  ***************************************************************
echo.
echo  Ihre Daten liegen in %pfadpbf%
echo.
echo  ***************************************************************
echo.
echo.
echo OSM-Daten in eine SpatiaLite-Datenbank schreiben
echo Kann ein wenig Dauern, so lange die osm.sqlite wächst, wird geschrieben
echo.
:: osmonf.ini wird in das PBF-Verzeichnis kopiert
copy "%HOMEDRIVE%%HOMEPATH%\Desktop\osm\osmconf.ini" "%pfadpbf%\osmconf.ini"    1>> meldungen.txt  2>> fehler.txt
::copy "%HOMEDRIVE%%HOMEPATH%\Desktop\osm\spalten_anlegen.sql" "%pfadpbf%\spalten_anlegen.sql"  1>> meldungen.txt  2>> fehler.txt
copy "%HOMEDRIVE%%HOMEPATH%\Desktop\osm\osm.qgz" "%pfadpbf%\osm.qgz" 1>> meldungen.txt  2>> fehler.txt
:: Verzeichniswechsel in das verzeichnis mit der PBF-datei
pushd "%pfadpbf%"

dir /B *.pbf > liste.txt
set /p pliste= < liste.txt
::echo < liste.txt
::echo  wird in die Datenbank %db% importiert
echo.
echo ***************************************************************
echo.
:: Über eine for-Schleife werden alle pbf-dateien eines Verzeichnisse importiert
:: ogr2ogr importiert über eine integrierte SQL-Abfrage die benötigent Inhhalte und legt diese in die über -nln definierten Layer


::if %raum%==n goto gesamt

:: Import mit räumlicher Einschränkung
:: pause
for %%x in (*.pbf) do (
ogr2ogr -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832  -nln strassen -lco GEOMETRY_NAME=geom  -lco FID=fid  -overwrite -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures %db%.sqlite %%x -sql "select name,highway,railway,usage,bridge,tunnel,ref,oneway  from lines where  highway in ( 'motorway' , 'primary' , 'secondary' , 'trunk' ) or (railway = 'rail' and usage = 'main')" 2>> fehler.txt

echo.
echo ##################################################
echo Linien geschrieben
echo ###################################################
echo.

ogr2ogr -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832  -nln poi  -lco GEOMETRY_NAME=geom  -lco FID=fid  -overwrite   -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures %db%.sqlite %%x -sql "select name,place,railway,public_transport,aeroway,aerodrome_type  from points where aeroway in ('aerodrome','terminal','runway') or public_transport= 'station' or railway= 'station' or place in ('town', 'city')" 2>> fehler.txt

echo.
echo ################################################
echo Punkte geschrieben
echo ################################################
echo.

ogr2ogr -progress --config GDAL_DATA "%ogrp%\share\epsg_csv" --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 5000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini  -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832  -nln flaechen  -lco GEOMETRY_NAME=geom  -lco FID=fid -overwrite -gt unlimited  -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  %db%.sqlite %%x -sql "select name,landuse,industrial,natural,leisure,waterway,aeroway,aerodrome_type,admin_level,boundary from multipolygons where landuse in ('industrial','commercial','residential','retail','forest','allotments','cemetery','grass','recreation_ground','village_green') or leisure in ('garden','park','pitch') or waterway is not NULL or natural in ('wood', 'water') or aeroway in ('aerodrome','terminal') or admin_level is not NULL " 2>> fehler.txt

echo.
echo ################################################
echo Flächen geschrieben
echo ################################################
echo.

)
echo.
echo ################################################
echo Weitere Verarbeitungsschritte in der Datenbank
echo ################################################
echo.

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -dialect sqlite -sql "delete from flaechen where (ST_area(geom) / 10000) < 1 or ((st_area(geom) / 10000) < 100 and (landuse = 'forest' or natural = 'wood' or natural = 'water'));" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite  -sql "alter table flaechen add column gruenflaeche integer;" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite  -sql "update flaechen set gruenflaeche = (case when leisure is not NULL or landuse in ('allotments','cemetery','grass','recreation_ground','village_green') then 1 else 0 end);" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite  -sql "alter table flaechen add column wirtschaft integer;" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -sql "update flaechen set wirtschaft = (case when landuse  in ('industrial','commercial','residential','retail') then 1 else 0 end);" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite  -sql "alter table flaechen add column wohnen integer;" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -sql "update flaechen set wohnen = (case when landuse  ='residential' then 1 else 0 end);" 1>> meldungen.txt  2>> fehler.txt


ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -dialect sqlite -sql "create table Flugplatz as select name, aeroway, aerodrome_type, st_pointonsurface(geom) as geom from flaechen where aerodrome_type like '%public%' UNION select name, aeroway, aerodrome_type, geom as geom from poi where aeroway is not null  and name is not NULL and name not like 'Milit%';" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -dialect sqlite -sql "select recovergeometrycolumn('Flugplatz','geom',25832,'Point');" 1>> meldungen.txt  2>> fehler.txt
ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -dialect sqlite -sql "select createspatialindex('Flugplatz','geom');" 1>> meldungen.txt  2>> fehler.txt
ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -dialect sqlite -sql "select updatelayerstatistics('Flugplatz')" 1>> meldungen.txt  2>> fehler.txt


ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -dialect sqlite -sql "select updatelayerstatistics('flaechen');" 1>> meldungen.txt  2>> fehler.txt

ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -sql "vacuum;" 1>> meldungen.txt  2>> fehler.txt

:: pause

:: Spalten anlegen etc
:: echo.
echo.
echo ################################################
echo Fertig
echo ################################################
echo.

:: echo.
:: echo Spalten anlegen
:: echo.
:: spatialite -silent %db%.sqlite < spalten_anlegen.sql


::Variable fuer das Starten von qgis setzen
set /p qg="Soll QGIS gestartet werden, um das Projekt zu öffnen? ja oder nein "
if %qg%==nein goto endef
echo.
echo ***************************************************************

:: Ausdehnung der Layer ermitteln und in Datei schreiben, um QGIS gleich mit dem richtigen Ausschnitt starten zu können


 echo Ermittelte Ausdehnung als Variable aus der Datei lesen und speichern
echo.
ogrinfo --config GDAL_DATA "%ogrp%\share\epsg_csv" %db%.sqlite -dialect sqlite -sql "select casttointeger(MBrMinx(geom))||','||casttointeger(MBrMiny(geom))||','||casttointeger(MBrMaxx(geom))||','||casttointeger(MBrMaxy(geom)) as geom from (select(GetLayerExtent('flaechennutzung','geom')) as geom)" > ext.txt
echo.

setlocal enabledelayedexpansion
for /F %%x in (ext.txt) do (set exte=%%x)
echo !exte!




if not exist  "%ogrp%\qgis.bat" goto qf
call qgis --extent !exte! --project osm.qgz 1>> meldungen.txt  2>> fehler.txt
:: --extent !exte!
goto end
:qf
call qgis-ltr --extent !exte! --project osm.qgz 1>> meldungen.txt  2>> fehler.txt
:end
:endef
echo.
echo.
exit







