#SKRIPT ZUM WORKSHOP OGR2OGR AUF DER FOSSGIS 2018 IN kassel


------------
GKG-Kassel - Dr.-Ing. Claas Leiner

Geodatenservice, Kartenwerkstatt &
GIS-Schule Kassel

Wilhelmshöher Allee 304 E
34131 Kassel
Tel. 0561/56013445
claas.leiner@gkg-kassel.de
http://www.gkg-kassel.de
-----------------------------
Unterstützen Sie QGIS
----------------------------
QGIS-DE e.V. | http://qgis.de
QGIS Projekt | http://qgis.org/de/site/ 
----------------------
#Infos
ogr2ogr ist ein Kommandozeilenprogramm zum konvertieren von Vektorgeodaten. ogr2ogr bietet SQL-Unterstützung und ist auch zum
umprojizieren von Vektordaten geeigent. Einige Toolboxwerkzeuge im qgis (rubrik GDAL / OGR) generieren ogr2ogr-Aufrufe.
Sehr geeignet zum Import von OSM-Rohdaten und NAS-XML in PostGis und SpatiaLite-Datenbanken, insbesondere bei großen Datenmengen.
Über kleine Shellskripte lassen sich ganze Verzeichnisse mit Shapes umprojizieren oder in eine Datenbank schreiben.
Mit integrierten SQL-Abfragen lassen sich schon beim Import Inhalte auswählen.
Und vielens mehr.


#Absetzen der Kommandos:
Linux: 		In der voreingestellten Kommandozeile (bash)
Windows:	In die OsGeo4w-Shell (Aus der QGIS-Pprogrammgruppe zu öffnen)
MacOsX: 	In der voreingestellten Kommandozeile 

Liste der auf dem eigenen Rechner unterstützten Formate			ogrinfo --formats

#Webquellen mit wchtigen Informationen
Hauptseite Ogr2ogr mit allen Parametern:				http://www.gdal.org/ogr2ogr.html
Übersicht über unterstützte Formate und formatspezifische Optionen:	
(-lco LayerCreation Options und -dco DatabaseCreation Options)		http://www.gdal.org/ogr_formats.html
SQLITE-SQL-Dialekt:							http://www.gdal.org/ogr_sql_sqlite.html
OGR-SQL-Dialekt:							http://www.gdal.org/ogr_sql.html
Weitere Konfigurationsoptionen:						https://trac.osgeo.org/gdal/wiki/ConfigOptions

#Kommandoaufruf: ogr2ogr -f "Ausgabeformat" -Optionen ZIEL QUELLE

# Optionen: -lco LayerCreation Options und -dco  -dco DatabaseCreation Options sind Formatspezifisch

# 1. Unterstützte Formate prüfen
ogr2ogr --formats
--------------------------


# 2. OSM-DATEI NACH SHAPEFILE KONVERTIEREN UND DABEI NACH ETRS89 / UTM32N UMPROJIZIEREN

ogr2ogr -f "ESRI Shapefile" -s_srs EPSG:4326 -t_srs EPSG:25832 osmshapes kassel.pbf

Zieldatenformat: 		     -f "ESRI Shapefile" (hier Shapefile)
Quell-Koordinatensystem:	  -s_srs EPSG:4326 (Geographisch WGS 84)
Ziel-Koordinatensystem:		-t_srs EPSG:25832 (ETRS89/UTM32N)
Quelldatei:			          osmquelle (hier kassel.pbf)
Ziel:			Shapeausgebeverzeichnis (hier osmshapes) (dort werden Shapefiles für Polygone, Linien und Punkte geschrieben)

#mit weiteren Optionen
ogr2ogr -f "ESRI Shapefile" -s_srs EPSG:4326 -t_srs EPSG:25832 -lco ENCODING=UTF-8 -lco SPATIAL_INDEX=YES -skipfailures osmshapes kassel.pbf
-lco ENCODING=UTF-8 		Zeichencodierung für Shapes setzen, im Beispiel utf-8
-lco SPATIAL_INDEX=YES		Räumlichen Index erzeugen für perfomanteres arbeiten mit großen Shapes
-skipfailures			    Kein Abbruch bei Verarbeitungsfehlern

----------------------------------------------
# 3. OSM-DATEI NACH SQLITE KONVERTIEREN DABEI NACH ETRS89 / UTM32N UMPROJIZIEREN

ogr2ogr -f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures ziel.sqlite osmquelle.osm/pbf
ogr2ogr -f "GPKG"   -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures ziel.gpkg osmquelle.osm/pbf

-f  "SQLite" 			    Zieldatenformat:(hier sqlite)
-dsco SPATIALITE=yes 		Es wird eine SpatiaLite-Datenbank mit allen räumlichen Funktionen und keine nackte SQLite-Datei erstellt
-lco SRID=25832             Beschreibung des Koordinatensystems, ansonsten wird es beim Laden der Layer in qgis jedes mal abgefragt
-s_srs EPSG:4326 		     Quell-Koordinatensystem: (Geographisch WGS 84)
-t_srs EPSG:25832		     Ziel-Koordinatensystem: (ETRS89/UTM32N)
-gt unlimited			(Anzahl der Zeilen, die mit jeder Transaction gesetzt wird) unlimited = in einer Transaktion
-skipfailures			    Schreiben bricht bei Fehlern nicht ab, sondern wird fortgesetzt.
Quelldatei:			      osmquelle
Ziel:				       ziel.sqlite (In der SQLIE-Datei werden verschiedene Layer angelegt - bei OSM Multipolygons, line, Points)

-------------------------------------------------------------
#MIT ZUSÄTZLICHEN OPTIONEN ZUR ERHÖHUNG DER PERFORMANCE

ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 4000 -progress -f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832 -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  kassel.sqlite kassel.pbf

ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 4000 -progress -f "GPKG"  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures  kassel.gpkg kassel.pbf

-progress				                    Eine Fortschrittsmeldung wird angezeigt
--config OGR_SQLITE_SYNCHRONOUS OFF	        Ohne diese Option läuft es sehr langsam, mit sehr viel schneller
                                            theoretisch Risiko des Datenverlustes, beim Update einer Datenbank, 
                                            wenn es beim Import zum Programmabsturz kommt.

--config OGR_SQLITE_CACHE 8192          oder höher - Zwischenspeicher erhöht perfomance
--config OSM_MAX_TMPFILE_SIZE 4000 	    Maximale Größe der im Arbeitspseicher gehaltenen temporären Datei: Möglichst hoch setzen

2>> ogrmeldungen.txt			An den Befehl anhängen, um Meldungen in eine Datei zu schreiben 

----------------------------
-------------------------------------
# 4. Als Shell-Skript osm2sqlite.sh mit Eingabe der Dateinamen
#Nach /home/username/bin kopieren und als ausführbar kennzeichnen Befehl: chmod  a+x osm2sqlite.sh
# oder mit den Dateimanager in den Eigenschaften
-------------
#!/bin/bash
read -p "Namen der resultierenden SQLITE-Datenbank ohne Dateiendung eingeben und return drücken:   " db
echo
echo
read -p "Namen der OSM-Datei eingeben   " osm
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 4000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini -progress -f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures $db.sqlite $osm
---------------------------------------------------------------------------------
#Als Windows-Bat osm2sqlite.bat
#Nach C:\pfad_der_qgisinstallation\bin kopieren und mit der osgeo4w-Shell ausführen

-------------
set /p db="Namen der resultierenden SQLITE-Datenbank ohne Dateiendung eingeben und return drücken:   "
echo.
echo.
set /p osm="Namen der OSM-Datei eingeben   "
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS off --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 4000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini -progress -f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures %db%.sqlite %osm%

-----------------------------------------------------------------------------------------
--------------------------------------------------------------
--------------------------------------------------------------------------
#5. MIT EINER SQL-Auswahl NUR GEBÄUDE IN EINEN LAYER SCHREIBEN
# Befehl mehrzeilig durch \ Zeilenumbrüche eingefügt Im windows muss wirder alles in einer Zeile stehen

ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 4000 --config OSM_COMPRESS_NODES YES -progress \
-f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832 -nln gebaeude  -gt unlimited -update -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures kassel.sqlite kassel.pbf \
-sql "select name,building from multipolygons where building is not null"

-update				Die Datei wird nicht überschrieben, es werden neue Layer in der SQLite-Datei rangelegt
-overwrite			-overwrite (hier nicht verwendet) bewirkt ein überschreiben der Datei
-nln gebaeude	                Der Ergebnislayer heißt Gebäude
-sql "select name,building from multipolygons where building is not null"
SQL-Abfrage zur Audwahl der Gebäude


------------------------------------------------------------
# 6. EXTRAKTION DER EISENBAHN in einen Layer verkehr
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 4000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini -progress \
-f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832 -nln verkehr  -gt unlimited -update -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures kassel.sqlite kassel.pbf \
-sql "select name,railway from lines where railway is not null"

--config OSM_CONFIG_FILE osmconf.ini		Eine benutzerdefinierte OSM-Datei zur Definition der Attributspalten 
						Liegt im selben Verzeichnis und sorgt dafür, die Spalte railway anzulegen
-update						Die Datenbank wird nicht überschrieben sondern geändert
-nln verkehr					der resultierende Layer heißt verkehr

-------------------------------------------------------------------------------------------
# 7. EXTRAKTION DER STRASSENNETZES und 
# Straßennetz und Eisenbahn könnten auch in eine SQL-Abfrage geschrieben werden:
-sql "select name,highway,railway,bridge,tunnel,ref from lines where highway is not null and railway is not null"
## Wir tun jetzt aber so, als hätten wir es vergessen, um das Anfügen von Zeilen zu testen:

ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 --config OSM_MAX_TMPFILE_SIZE 4000 --config OSM_COMPRESS_NODES YES --config OSM_CONFIG_FILE osmconf.ini -progress \
-f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832 -nln verkehr -update -addfields  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures kassel.sqlite kassel.pbf \
-sql "select name,highway,bridge,tunnel,ref from lines where highway is not null"

-append				Weitere Zeilen an eine vorhandene Tabelle anhängen.
-addfields			Wie append, es werden fehlende Spalten angelegt, wenn der zweite Datensatz über mehr Spalten verfügt
				diese Option wird angewendet

# 7b--------------------------------------------------------------------------------------
# Shapefiles in ein geopackage schreiben
#!/bin/bash
echo
echo
echo -n "Shapes in ein Geopackage schreiben"
echo
echo
read -p "Namen der resultierenden GPKG-Datei ohne Endung eingeben: " nam
echo
echo
read -p "Bitte Pfad zur sqlite-Datei eingeben oder via rechte Maustaste aus der Zwischenablage einfuegen: " pfa
echo
echo
cd "$pfa"
for i in *.sqlite; do ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 -f GPKG -skipfailures -update -append -gt unlimited $nam.gpkg $i; done


--------------- ----------------------------------------------------------------------------
# 8.Räumlicher Ausschnitt wählen mit
-clipsrc xmin ymin xmax ymax    Schneidet die zu importierenden Daten auf die angegebene Ausdehnung  in 
				Koordinaten des Quell-KBS zu: -clipsrc 8.47101 50.01627 8.80373 50.22891

-spat  xmin ymin xmax ymax	Import der Daten nach räumlicher Auswahl 0hne zuschneiden, bei Angebae von:
-spat_srs srs_def:		Kann des Koordinatensystem gewählt werden

Beispiel in ETRS89/UTM32	-spat 551537 5984753 578712 6001370 -spat_srs EPSG:25832


---------------------------
# 9. Import in  EINE POSTGIS-DATENBANK
ogr2ogr  -progress --config PG_USE_COPY YES --config OSM_CONFIG_FILE osmconf.ini --config OSM_MAX_TMPFILE_SIZE 4000 \
 -f PostgreSQL PG:"dbname='fossgis' host='h2834776.stratoserver.net' port='5432' user='fg1' active_schema=fg1 password='fg1'" \
 -geomfield geom -nln rathaus -update  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures kassel.pbf \
 -sql "select * from multipolygons where name = 'Neues Rathaus'"
 
 ogr2ogr  -progress --config PG_USE_COPY YES --config OSM_CONFIG_FILE osmconf.ini --config OSM_MAX_TMPFILE_SIZE 4000 \
 -f PostgreSQL PG:"dbname='fossgis' host='h2834776.stratoserver.net' port='5432' user='fg1' active_schema=fg1 password='fg1'" \
 -geomfield geom -nln bundesstrasse -update  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures kassel.pbf \
 -sql "select * from lines where highway = 'primary'"
 
  ogr2ogr  -progress --config PG_USE_COPY YES --config OSM_CONFIG_FILE osmconf.ini --config OSM_MAX_TMPFILE_SIZE 4000 \
 -f PostgreSQL PG:"dbname='fossgis' host='h2834776.stratoserver.net' port='5432' user='fg1' active_schema=fg1 password='fg1'" \
 -geomfield geom -nln bundesstrasse -update  -gt unlimited -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures kassel.pbf \
 -sql "select * from lines where name like 'Bismar%"

--config PG_USE_COPY YES        Zeilen werden in einer Tranasction kopiert statt via insert eingefügt: viel schneller
PG:"dbname='datenbankname' host='servername' port='5432' user='user' active_schema=fg1 password='schema wenn nicht public'"    Adresse der datenbank

------------------------
# 10. UMPROJIZIEREN VON SHAPEFILES
ogr2ogr -t_srs EPSG:25832 -s_srs EPSG:31467 -f "ESRI Shapefile"  -skipfailures gemeinden_etrs.shp gemeinden_gk3.shp
ogr2ogr -t_srs EPSG:25832 -s_srs EPSG:31467 -f "ESRI Shapefile" -lco ENCODING=UTF-8 -lco SPATIAL_INDEX=YES -skipfailures gemeinden_etrs2.shp gemeinden_gk3.shp

-s_srs Quel-Kkoordinatensystem 	Definition durch EPSG-Code oder proj-String
-t_srs Ziel-Koordinatensystem	Definition durch EPSG-Code oder proj-String

-lco ENCODING=UTF-8 		Zeichencodierung für Shapes setzen
-lco SPATIAL_INDEX=YES		Räumlichen Indes erzeugen

#MIT BETA2007
# Für ein genaues umprojizieren, muss ein NTV-Grid wie BETA2007.gsb verwendet werden, wird mit QGIS unter Windows installiert
# Ansonsten download: 
ogr2ogr -t_srs EPSG:25832 -s_srs "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +datum=potsdam +nadgrids=./BETA2007.gsb +units=m +no_defs" -f "ESRI Shapefile" -lco ENCODING=UTF-8 -lco SPATIAL_INDEX=YES -skipfailures gemeinden_etrs_beta.shp gemeinden_gk3.shp 

-s_rs "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +datum=potsdam +nadgrids=./BETA2007.gsb +units=m +no_defs"

Einbindung des Grids BETA2007.gsb über vollen proj-String, im Zwiefelsfall absoluten Pfad zur GRID-Datei angeben. 
Wenn BETA2007.gsb mit proj installiert ist genügt +nadgrids=BETA2007.gsb 
# nadgrids=./BETA2007.gsb unter Linux meint, dass die Datei im aktuellen Verzeichnis liegt.

------------------------------------------
----------
# 11. BATCHDATEIEN UM VERZEICHNISSE MIT SHAPES VON GK3 NACH UTM ZU PROJIZIEREN
#Für linux
gk3_2_utm.sh
# Nach /home/username/bin kopieren und als ausführbar kennzeichnen Befehl: chmod  a+x gk3_2_utm.sh

#!/bin/bash
for shgk in *.shp; do
ogr2ogr -s_srs "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +datum=potsdam +nadgrids=./BETA2007.gsb +units=m +no_defs" -t_srs EPSG:25832  -f "ESRI Shapefile" -lco ENCODING=UTF-8 -lco SPATIAL_INDEX=YES -skipfailures $shgk.gk3.shp $shgk
done
---------------------
#für Windows
gk3_2_utm.bat
#  Windows-Bat-Dateien nach Nach C:\pfad_der_qgisinstallation\bin kopieren und mit der osgeo4w-Shell ausführen

for %%x in (*.shp) do (
ogr2ogr -s_srs "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +datum=potsdam +nadgrids=BETA2007.gsb +units=m +no_defs" -t_srs EPSG:25832  -f "ESRI Shapefile" -lco ENCODING=UTF-8 -lco SPATIAL_INDEX=YES -skipfailures  %%x.gk3.shp %%x
)

-----------
----------
# 12. BATCHDATEIEN UM VERZEICHNISSE MIT SHAPES VON UTM NACH GK3 ZU PROJIZIEREN

# Für Linux
utm2gk3.sh
# Nach /home/username/bin kopieren und als ausführbar kennzeichnen Befehl: chmod  a+x utm2gk3.sh

#!/bin/bash
for shgk in *.shp; do
ogr2ogr -s_srs EPSG:25832 -t_srs "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +datum=potsdam +nadgrids=./BETA2007.gsb +units=m +no_defs" -f "ESRI Shapefile" -lco ENCODING=UTF-8 -lco SPATIAL_INDEX=YES -skipfailures $shgk.gk3.shp $shgk
done
---------------------
#Für Windows
utm2gk3.bat
#  Windows-Bat-Dateien nach Nach C:\pfad_der_qgisinstallation\bin kopieren und mit der osgeo4w-Shell ausführen

for %%x in (*.shp) do (
ogr2ogr -s_srs EPSG:25832 -t_srs "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +datum=potsdam +nadgrids=BETA2007.gsb +units=m +no_defs" -f "ESRI Shapefile" -lco ENCODING=UTF-8 -lco SPATIAL_INDEX=YES -skipfailures  %%x.gk3.shp %%x
)
-----------
----------------------------------------------------------------------------


#Konvertierung einer NAS-XML-Datei nach SpatiaLite mit folgendem Befehl in der OSGeo4wShell unter Windows oder in der Linux-Bash:


ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 -progress -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -skipfailures -addfields  -gt unlimited -a_srs EPSG:25832  ziel.sqlite quelle.xml

# EPSG-Code in verschiedenen Ländern anders, so BaWue beim umprojizieren nach UTM32
 ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 -progress -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -skipfailures -addfields  -gt unlimited -s_srs "+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=500000 +y_0=0 +ellps=bessel +datum=potsdam +nadgrids=BETA2007.gsb +units=m +no_defs" -t_srs EPSG:25832  ziel.sqlite quelle.xml 

-nlt PROMOTE_TO_MULTI		Zu Multipart-Geometrie konvertieren, Häufig sinnvoll damit keine Mischung von geometrietypen vorkommt.
-addfields			Alternative zu append  Wenn neue Layer neue Spalten mitbringen, werden diese anglegt.

ogr2ogr --config NAS_GFS_TEMPLATE  "alkis-schema.gfs" --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 8192 -progress -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 \
-nlt CONVERT_TO_LINEAR   -fieldTypeToString integer -skipfailures -addfields   -gt unlimited -a_srs EPSG:25832  alkis_ges.sqlite ba_nas.xml  2>> ogrmeldungen.txt

-------------------------------------------
#ALKIS NRW
unter der folgenden Adresse lassen sich die ALKIS-Daten mit Gebäuden ejweils für einzelne Landkreise in NRW herunterladen:

https://www.opengeodata.nrw.de/produkte/geobasis/lika/alkis_sek/bda_oe/

Nach dem entpacken finden sich dort verschiedene Dateien:
unter fachinformationen_31001_bda.xml.gz finden sich die Gebäude.
Dieses Archiv entpacken und die Datei fachinformationen_31001_bda.xml steht für den Import bereit:
Beispiel Import nach PostGis

ogr2ogr -progress --config PG_USE_COPY YES  -f PostgreSQL PG:"dbname='alkis' host='localhost' port='5432' user='nutzer' password='passwort'" -nln gebaeude -gt unlimited -skipfailures -a_srs EPSG:25832 fachinformationen_31001_bda.xml

für die einzelnen Landkreise lässt die Tabelle gebaeude damm mit -append ergänzen:
ogr2ogr -progress --config PG_USE_COPY YES  -f PostgreSQL PG:"dbname='alkis' host='localhost' port='5432' user='nutzer' password='passwort'" -nln gebaeude -addfields -gt unlimited -skipfailures -a_srs EPSG:25832 fachinformationen_31001_bda.xml 

Flurstücke
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF --config OGR_SQLITE_CACHE 1024 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -gt unlimited -a_srs EPSG:25832 ziel.sqlite fachinformationen_11003_bda.xml
ogr2ogr -progress --config PG_USE_COPY YES  -f PostgreSQL PG:"dbname='ziel' host='localhost' port='5432' user='claas' password='passwd'" -gt unlimited -skipfailures -a_srs EPSG:25832 fachinformationen_11003_bda.xml
------------------------------------------------



#BATCH-DATEIVORLAGEN FÜR WINDOWS UND LINUX (ALLE BESIPIELE FÜR KBS EPSG:25832, GEGEBENENFALLS ANPASSEN)
# Windows-Bat-Dateien nach Nach C:\pfad_der_qgisinstallation\bin kopieren und mit der osgeo4w-Shell ausführen
# Linux Shellskripte n /home/username/bin kopieren und als ausführbar kennzeichnen Befehl: chmod  a+x dateiname oder
# Mit dem dateimanager in den Dateieigenschaften

------------------------------
#Shellskript für Linux: shp2sqlite Shapes in eine SQLITE-Datei konvertieren

#!/bin/bash
for shps in *.shp; do
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -skipfailures -update -addfields -gt unlimited -a_srs EPSG:25832 ziel.sqlite $shps
done
------------------------------

#Batchdatei für Windows: shp2sqlite.bat  Shapes in eine SQLITE-Datei konvertieren
@echo off
echo Shapes in eine SpatiaLite-Datenbank schreiben
set /p db="Namen der resultierenden SQlite-Datei ohne Endung eingeben: " 

set /p pfa="Bitte Pfad zu den Shapes eingeben oder via rechte Maustaste aus der Zwischenablage einfuegen: "
%lauf%
pushd "%pfa%"
for %%i in (*.shp) do (
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -skipfailures -update  -addfields -gt unlimited -a_srs EPSG:25832 %db%.sqlite %%i
)

--------------------------
-------------------------
#Shellskript für Linux: xml2sqlite (Konvertiert alle NAS-XML eines Verzeichnisses in eine Sqlite-datei)

#!/bin/bash
for xmls in *.xml; do
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -skipfailures -update -addfields -gt unlimited -a_srs EPSG:25832 ergebnis.sqlite $xmls
done 

----------------------
#Batchdatei für Windows: xml2sqlite.bat (Konvertiert alle NAS-XML eines Verzeichnisses in eine Sqlite-datei)

for %%x in (*.xml) do (
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -skipfailures -update -addfields -gt unlimited -a_srs EPSG:25832 ergebnis.sqlite %%x
)


 ----------------------
------------------------
#Shellskript für Linux: xml2esqlite.sh (Konvertiert alle NAS-XML in einzelene SQLITE-Dateien)

#!/bin/bash
for xmls in *.xml; do
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI -skipfailures -gt unlimited -a_srs EPSG:25832 $xmls.sqlite $xmls
done 

----------------
#Batchdatei für Windows: xml2esqlite.bat (Konvertiert alle NAS-XML in einzelene SQLITE-Dateien)

for %%x in (*.xml) do (
ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 8192 -f "SQLite" -dsco SPATIALITE=yes -lco SRID=25832 -nlt PROMOTE_TO_MULTI  -skipfailures -gt unlimited -a_srs EPSG:25832 %%x.sqlite %%x
)



-----------
-----------------
#EINZELNE GEOMETRIEN AUS KML-DATEIEN EXTRAHIEREN

ogr2ogr --config OGR_SQLITE_SYNCHRONOUS OFF  --config OGR_SQLITE_CACHE 1024 -f "SQLite" -dsco SPATIALITE=yes  -lco SRID=25832  -gt 65536 -s_srs EPSG:4326 -t_srs EPSG:25832 -skipfailures -append -explodecollections  doc.sqlite doc.kml -where Geometry = point
ogr2ogr -f "ESRI Shapefile"  -s_srs EPSG:4326 -t_srs EPSG:25832  -skipfailures  -explodecollections -append  shapes  doc.kml -sql "select * from doc where OGR_GEOMETRY='POINT'" -lco SHPT=POINT

-explodecollections        löst Geometriecollections in Punkte, Linien und Polygone auf
-where Geometry = point    wahlt die Punktgeometrien aus
-sql "select * from doc where OGR_GEOMETRY='POINT'" -lco SHPT=POINT   wahlt die Punktgeometrien aus, anderes verfahren




------------
GKG-Kassel - Dr.-Ing. Claas Leiner
QGIS-Support und mehr

Geodatenservice, Kartenwerkstatt &
GIS-Schule Kassel

Wilhelmshöher Allee 304 E
34131 Kassel
Tel. 0561/56013445
claas.leiner@gkg-kassel.de
http://www.gkg-kassel.de
----------------------------------------
Unterstützen Sie QGIS
QGIS-DE e.V. | http://qgis.de
 







